// C Source File
// Created 7/20/2002; 4:02:04 AM

// By Samuel Stearley copyright 2002
// sstear70@calvin.edu
// www.calvin.edu/~sstear70/


#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define NO_AMS_CHECK
#define NO_CALC_DETECT
#include <tigcclib.h>         // Include All Header Files



void DrawStrXY_2(int x,int y,char * ptr){
	DrawStrXY(x,y,ptr,A_NORMAL);
}

void DisplayColumn(int x,unsigned char tag1,unsigned char tag2,int count){
	int cord = 0,i;
	int x2 = x+32;
	for (i = 0;i<count;i++){
	  char result[] = "            \0";    // 10 spaces and \0
		sprintf(result,"%d(%X)",tag2,tag2);
		DrawStrXY_2(x,cord,result);
		if (tag1)
			DrawStrXY(x2,cord,get_key_ptr(tag1,tag2),A_NORMAL);
		else
			DrawStrXY(x2,cord,get_key_ptr(tag2,tag1),A_NORMAL);
		cord += 6;
		tag2++;
	}
}

void _main(void){
	FontSetSys(0);
	unsigned char	tagMajor = 0;
	unsigned char tagExtended = 0;
	for (;;){
		clrscr();
		DisplayColumn(0,tagExtended,tagMajor,16);
		DisplayColumn(80,tagExtended,tagMajor+16,16);
		int key	= ngetchx();
		if (key == KEY_APPS){
			clrscr();
			DrawStrXY_2(20,20,"Tags By Samuel Stearley");
			DrawStrXY_2(20,27,"Copyright 2002");
			DrawStrXY_2(20,41,"sstear70@calvin.edu");
			DrawStrXY_2(20,48,"www.calvin.edu/~sstear70/");
			DrawStrXY_2(20,62,"F1-Normal Tags");
			DrawStrXY_2(20,69,"F2-Extended Tags (0xE3)");
			DrawStrXY_2(20,76,"F3-Tibasic Tags (0xE4)");
			DrawStrXY_2(20,83,"F4-System Variables (0x1C)");
			key =ngetchx();
		}
		if (key == KEY_ESC) break;
		if ( (key == KEY_UP) && (tagMajor > 0))
			tagMajor -= 32;
		else if ( (key == KEY_DOWN) && (tagMajor < (256-32)))
			tagMajor += 32;
		else{
			tagMajor = 0;
			if (key == KEY_F3) tagExtended = EXT_INSTR_TAG;
			if (key == KEY_F2) tagExtended = EXT_TAG;
			if (key == KEY_F1) tagExtended = 0;
			if (key == KEY_F4) tagExtended = EXT_SYSTEM_TAG;
		}
	}
}
